"use strict";

this.EXPORTED_SYMBOLS = ["UnMHTFennecMenu"];

(function(module) {

let { classes: Cc, interfaces: Ci, results: Cr, utils: Cu } = Components;
let { arFennecMenu } = Cu.import("resource://unmht/modules/base/arFennecMenu.jsm", {});
let { arWindowUtils } = Cu.import("resource://unmht/modules/base/arWindowUtils.jsm", {});
let { arWindowWatcher } = Cu.import("resource://unmht/modules/base/arWindowWatcher.jsm", {});
let { UnMHTFileSaver } = Cu.import("resource://unmht/modules/UnMHTFileSaver.jsm", {});
let { TEXT } = Cu.import("resource://unmht/modules/UnMHTStringBundle.jsm", {});

let iconURL
  = "data:image/png;base64,"
  + "iVBORw0KGgoAAAANSUhEUgAAAEAAAABACAYAAACqaXHeAAAACXBIWXMAAA3XAAAN1wFCKJt4A"
  + "AAKTWlDQ1BQaG90b3Nob3AgSUNDIHByb2ZpbGUAAHjanVN3WJP3Fj7f92UPVkLY8LGXbIEAIi"
  + "OsCMgQWaIQkgBhhBASQMWFiApWFBURnEhVxILVCkidiOKgKLhnQYqIWotVXDjuH9yntX167+3"
  + "t+9f7vOec5/zOec8PgBESJpHmomoAOVKFPDrYH49PSMTJvYACFUjgBCAQ5svCZwXFAADwA3l4"
  + "fnSwP/wBr28AAgBw1S4kEsfh/4O6UCZXACCRAOAiEucLAZBSAMguVMgUAMgYALBTs2QKAJQAA"
  + "Gx5fEIiAKoNAOz0ST4FANipk9wXANiiHKkIAI0BAJkoRyQCQLsAYFWBUiwCwMIAoKxAIi4EwK"
  + "4BgFm2MkcCgL0FAHaOWJAPQGAAgJlCLMwAIDgCAEMeE80DIEwDoDDSv+CpX3CFuEgBAMDLlc2"
  + "XS9IzFLiV0Bp38vDg4iHiwmyxQmEXKRBmCeQinJebIxNI5wNMzgwAABr50cH+OD+Q5+bk4eZm"
  + "52zv9MWi/mvwbyI+IfHf/ryMAgQAEE7P79pf5eXWA3DHAbB1v2upWwDaVgBo3/ldM9sJoFoK0"
  + "Hr5i3k4/EAenqFQyDwdHAoLC+0lYqG9MOOLPv8z4W/gi372/EAe/tt68ABxmkCZrcCjg/1xYW"
  + "52rlKO58sEQjFu9+cj/seFf/2OKdHiNLFcLBWK8ViJuFAiTcd5uVKRRCHJleIS6X8y8R+W/Qm"
  + "Tdw0ArIZPwE62B7XLbMB+7gECiw5Y0nYAQH7zLYwaC5EAEGc0Mnn3AACTv/mPQCsBAM2XpOMA"
  + "ALzoGFyolBdMxggAAESggSqwQQcMwRSswA6cwR28wBcCYQZEQAwkwDwQQgbkgBwKoRiWQRlUw"
  + "DrYBLWwAxqgEZrhELTBMTgN5+ASXIHrcBcGYBiewhi8hgkEQcgIE2EhOogRYo7YIs4IF5mOBC"
  + "JhSDSSgKQg6YgUUSLFyHKkAqlCapFdSCPyLXIUOY1cQPqQ28ggMor8irxHMZSBslED1AJ1QLm"
  + "oHxqKxqBz0XQ0D12AlqJr0Rq0Hj2AtqKn0UvodXQAfYqOY4DRMQ5mjNlhXIyHRWCJWBomxxZj"
  + "5Vg1Vo81Yx1YN3YVG8CeYe8IJAKLgBPsCF6EEMJsgpCQR1hMWEOoJewjtBK6CFcJg4Qxwicik"
  + "6hPtCV6EvnEeGI6sZBYRqwm7iEeIZ4lXicOE1+TSCQOyZLkTgohJZAySQtJa0jbSC2kU6Q+0h"
  + "BpnEwm65Btyd7kCLKArCCXkbeQD5BPkvvJw+S3FDrFiOJMCaIkUqSUEko1ZT/lBKWfMkKZoKp"
  + "Rzame1AiqiDqfWkltoHZQL1OHqRM0dZolzZsWQ8ukLaPV0JppZ2n3aC/pdLoJ3YMeRZfQl9Jr"
  + "6Afp5+mD9HcMDYYNg8dIYigZaxl7GacYtxkvmUymBdOXmchUMNcyG5lnmA+Yb1VYKvYqfBWRy"
  + "hKVOpVWlX6V56pUVXNVP9V5qgtUq1UPq15WfaZGVbNQ46kJ1Bar1akdVbupNq7OUndSj1DPUV"
  + "+jvl/9gvpjDbKGhUaghkijVGO3xhmNIRbGMmXxWELWclYD6yxrmE1iW7L57Ex2Bfsbdi97TFN"
  + "Dc6pmrGaRZp3mcc0BDsax4PA52ZxKziHODc57LQMtPy2x1mqtZq1+rTfaetq+2mLtcu0W7eva"
  + "73VwnUCdLJ31Om0693UJuja6UbqFutt1z+o+02PreekJ9cr1Dund0Uf1bfSj9Rfq79bv0R83M"
  + "DQINpAZbDE4Y/DMkGPoa5hpuNHwhOGoEctoupHEaKPRSaMnuCbuh2fjNXgXPmasbxxirDTeZd"
  + "xrPGFiaTLbpMSkxeS+Kc2Ua5pmutG003TMzMgs3KzYrMnsjjnVnGueYb7ZvNv8jYWlRZzFSos"
  + "2i8eW2pZ8ywWWTZb3rJhWPlZ5VvVW16xJ1lzrLOtt1ldsUBtXmwybOpvLtqitm63Edptt3xTi"
  + "FI8p0in1U27aMez87ArsmuwG7Tn2YfYl9m32zx3MHBId1jt0O3xydHXMdmxwvOuk4TTDqcSpw"
  + "+lXZxtnoXOd8zUXpkuQyxKXdpcXU22niqdun3rLleUa7rrStdP1o5u7m9yt2W3U3cw9xX2r+0"
  + "0umxvJXcM970H08PdY4nHM452nm6fC85DnL152Xlle+70eT7OcJp7WMG3I28Rb4L3Le2A6Pj1"
  + "l+s7pAz7GPgKfep+Hvqa+It89viN+1n6Zfgf8nvs7+sv9j/i/4XnyFvFOBWABwQHlAb2BGoGz"
  + "A2sDHwSZBKUHNQWNBbsGLww+FUIMCQ1ZH3KTb8AX8hv5YzPcZyya0RXKCJ0VWhv6MMwmTB7WE"
  + "Y6GzwjfEH5vpvlM6cy2CIjgR2yIuB9pGZkX+X0UKSoyqi7qUbRTdHF09yzWrORZ+2e9jvGPqY"
  + "y5O9tqtnJ2Z6xqbFJsY+ybuIC4qriBeIf4RfGXEnQTJAntieTE2MQ9ieNzAudsmjOc5JpUlnR"
  + "jruXcorkX5unOy553PFk1WZB8OIWYEpeyP+WDIEJQLxhP5aduTR0T8oSbhU9FvqKNolGxt7hK"
  + "PJLmnVaV9jjdO31D+miGT0Z1xjMJT1IreZEZkrkj801WRNberM/ZcdktOZSclJyjUg1plrQr1"
  + "zC3KLdPZisrkw3keeZtyhuTh8r35CP5c/PbFWyFTNGjtFKuUA4WTC+oK3hbGFt4uEi9SFrUM9"
  + "9m/ur5IwuCFny9kLBQuLCz2Lh4WfHgIr9FuxYji1MXdy4xXVK6ZHhp8NJ9y2jLspb9UOJYUlX"
  + "yannc8o5Sg9KlpUMrglc0lamUycturvRauWMVYZVkVe9ql9VbVn8qF5VfrHCsqK74sEa45uJX"
  + "Tl/VfPV5bdra3kq3yu3rSOuk626s91m/r0q9akHV0IbwDa0b8Y3lG19tSt50oXpq9Y7NtM3Kz"
  + "QM1YTXtW8y2rNvyoTaj9nqdf13LVv2tq7e+2Sba1r/dd3vzDoMdFTve75TsvLUreFdrvUV99W"
  + "7S7oLdjxpiG7q/5n7duEd3T8Wej3ulewf2Re/ranRvbNyvv7+yCW1SNo0eSDpw5ZuAb9qb7Zp"
  + "3tXBaKg7CQeXBJ9+mfHvjUOihzsPcw83fmX+39QjrSHkr0jq/dawto22gPaG97+iMo50dXh1H"
  + "vrf/fu8x42N1xzWPV56gnSg98fnkgpPjp2Snnp1OPz3Umdx590z8mWtdUV29Z0PPnj8XdO5Mt"
  + "1/3yfPe549d8Lxw9CL3Ytslt0utPa49R35w/eFIr1tv62X3y+1XPK509E3rO9Hv03/6asDVc9"
  + "f41y5dn3m978bsG7duJt0cuCW69fh29u0XdwruTNxdeo94r/y+2v3qB/oP6n+0/rFlwG3g+GD"
  + "AYM/DWQ/vDgmHnv6U/9OH4dJHzEfVI0YjjY+dHx8bDRq98mTOk+GnsqcTz8p+Vv9563Or59/9"
  + "4vtLz1j82PAL+YvPv655qfNy76uprzrHI8cfvM55PfGm/K3O233vuO+638e9H5ko/ED+UPPR+"
  + "mPHp9BP9z7nfP78L/eE8/sl0p8zAAAAIGNIUk0AAHolAACAgwAA+f8AAIDpAAB1MAAA6mAAAD"
  + "qYAAAXb5JfxUYAAArpSURBVHja7Jt5lBTVFcZ/I8swERxBcBCBCWsQAsMSlS0YIyrIuASiwQB"
  + "BQIYtUZKA4LgEEj0wIBEJKBgkiAQRkCgDYTMYNxQTE5QlgAjKjOjgBGaQfc0f9dWZl3eqqqur"
  + "G+QcuOf06a7q6qr37rvvu9/93uuU06dPcz7bRZzndsEBFxxwnlt5+8Q99w45E89JATKABkAmU"
  + "BNIB1KBo0Ap8CWwC/hEn5OKzrNnPhPOAUm0bwHXAzcD1wJZ6nAsOwpsAdYBy4C/A/vPWgQkwe"
  + "oDw4CeQC3j/F7gA2C7Xoc1yuUUDZmKkEZyVhaQA+wBXgSm6nfnrAPqAGOAXhrpU8C7wCvAW8B"
  + "HwEFd2wLYBxR43OcSoDnQFuih6LkfGAzMAx7XNDlnQDBNjdoM9AdOAs8ArYD2wAQ54jhwt0L7"
  + "Q+C3PvfbD7wDTNLvs3S/k0A/YCMwHrj4XHBAczU2Vw2aDTQFhmrE3SjrreN5wDU63xe4PcQzN"
  + "up+TYBZiq5Rcmrzb9IBPwLWaqQBRmqEPjOu6QasB14AvuORGWYDbUI+rwAYoKmxTp1/D/jJN+"
  + "GAocDLQGUdHwFeNb7P0GgvBZoF3OdS4DXgtjie/T7QCXhKmWa+QPesOaA7ME0j6NoWA6Fba1r"
  + "cHeJepcAOjWqFONpwDBhu4MjUkM9LOAvcCMz1OP8fvedoZCoF3OMLIF/h+4qyQVT7jdLpOOBP"
  + "4hCLz1QEtAIWCfVt2yW0n+HT+ePAcuFGI2AQcIPCt32CODZeDkjV4Fx9JhzgIvwloqlemDDS4"
  + "/xe4Emlsls04i4X+DZwk6bLGn1OieiEXJGlNGWK9GQ74FGRl3X6bFsV6/gAkKfU9StjiphTr7"
  + "pxfD2wUs7oEtEJw4B/Ad8FxibTAd/T6B5RPv80xvXzhPyjga8CIqqax/l2miqTIzhgH3CPcOB"
  + "+AWtSHJCr0JwopD/oc91WgWQvYUKQVdd08rNdEaNgg7DIBciEHdBBwPW5MSoHPK6boHn+WsiG"
  + "ZgRUhsXAnxMAxcnAbk2lTok6oI9bTgvQ8CEdLyv0wlglgw572SqgKAEH7FV7AQYm4oDLVI2dA"
  + "ubo3C+V670YnZ+VU2p6QixuvfDBz24Gngc6JqJ/qHi6VeJLJAfcoLm6EtimkPq9vrNxoK5PWT"
  + "tCoLlW6DxF5W1+gBhSFfiZSuiZorvx2sfAaqXDLlEd0E3vCxS203X8OPCQdW0T67g/sFMkZRH"
  + "QWA2ZK/rbyOeZvwD+YBwPEHeoFMEJi/SeHcUBqQaAvK6Ry1ToPgy84cESAWoAfwWeU7laX9Nm"
  + "p6Uf1PN45qdKocOBNy36PSmCA97We9sg7cDPAXX1Kga6CkyGidyg2n6DpQt0U6e7Sr3J9klnt"
  + "ZQFbJtlTK0Ros+uDdHUice2q0i7EmgYrwOa6LtqorKjgKeN709ZRUcNlb6VlTpnBDSsnkcKLF"
  + "Ex49o/rFSYovohHjtpMNDG8TqggfH9fINcmPai2KFrXwOdBXixiirbXgAKrXN/sY5/GAEQt+q"
  + "9fjwOKA9cbhwfCbh5vpXfw1iWR20/w4fVHbWmTq04HfC5QbxCOyAduMI4/r5yuV+YuVZBKB4L"
  + "dFta514CNvnoBkXW/a+IUB8E8hQvB9RQqepaU+Vw2/pJHfrIYo5NAxrUwEqBxwMQ/ohHMZUap"
  + "wOOG84L7YAMOcEEoDs8kHyyGt/FoMlpMYqQdkBF43gOjkTuZ4es48NxOiDVIFihHVDNQ1C40/"
  + "JinkBrjEL1AeO7u0Shvayz8bkwBiW2JbtjPmJMkFUxADq0A6p4oG0zypTbturkEDUKEZ/HjOu"
  + "f9ACsysAPLCcWBzQ+xZq7u/BeSQoyFzP2xJsFvEBvuN7HiQO8aX3/CGWCaR0PZG+n86gomh6j"
  + "8ekqyFx7x3B4WGtkkKLQDjiF99J0e9UFLQLm+QDK1geyVQuY08i1B4ETMRqfaaXj+RHosLsYs"
  + "yMeBxzyyP2FCsk7cZast/nc7xiOPr9Gx6Mko5UXRXaBb02IxrcwPm8O+RvT6igjFccbAaUeqs"
  + "9M8XM3AwStJxxWHb5Ax0+L59cWiD0csgMmXkyKEP5tlHH+rT6FdkCRAU7uVOgpLWCAdIJY8/c"
  + "Qzprdg0pFrrKUExLIMowydoUcGK+5qXtl2DRjMjB3uWqd2FRXnNXcWZqX44wCJWguj9cojI2T"
  + "LvfWcz6LUAQhISdbeLYkXj2gCGdJ2o2AbHUgRx0Yr/zdX7pAwxhEpI8QfCjOmuJ9MRqfpmtLc"
  + "JbPoyjEPZVBVkkdilsQ+afea2sEx2hULjZyeHeBzCZFhJfIcZ+c2ANnk0NjSV4/DmjTYOXt1j"
  + "FYYpDo6gq302Jd7Adm6zUClyucCi1Vxy1X98g5o8UT3laVeEoN6SgxpbJycqo4QDs5b68cfFq"
  + "Z5zhwlaZb1LWBQdIz3lPGiuSArxS23YT6hT7XXS2l5oQ63Nmiu+Ds8vKyE+q4V6EyUMi9Xu1Y"
  + "ITyKlQlqG3rlWEJstQtKZ0vkgHoaNZdZFVG2bW2yMGCYpeyWCkw/xNnQdFAR9YUipFTEarxGP"
  + "E/hmi55LUuOvE6vXDnjCRGtAz5tnqhCbrmcRqIOmIqzavuSzlWV2povKrwF+LmwxN1huUUagl"
  + "cBUkHKTm/hQpo67hZFBQLghcoA9ShbQ2wpql0i5XiKVUuMEviV4izIhrIgWfxLpb1+hj7wvqS"
  + "wh5RfP5buVtuovbPw3/xUSZ3tTdk+g2Hq7ARDuzsh0MwyKPBekbGlqjt2qgpNwVm+c2n3rzUI"
  + "CTvArepSFIJmbncFzIoCnFutuTwFb+3f1Q3vwlm42Geo0CNFeZdQtvurUNS6h+bzoxJMr9FUy"
  + "BNYPqfrc43PSXHAVtHQgZTt5Civ49UGU3tE1d9shekHFpW1ZbSFmlo1da8SfbdfTrIlrMUqjp"
  + "bibMGZI4S/UQ6oKoCsjLMRI7R2GGaP0O9UBE0XIE1TusuTU65V2G32qOeDnnudSNIdSpu5esa"
  + "+ADG1hSFz/1RzvYOiaoQRqVNw9ggkxQGlwL1iVU9phKYJiS+S999Qg1Ybv/NKQVcKLLsL/VG+"
  + "zgb+6/P8miJafeXUfOFGgUXc3EWV5bo+KVPAtdUCrz4421lchWerXtUEirFobjkB5FXWyE7EX"
  + "7uvK5xJMXJ9O+O4qlJkd2WFqfFIZ/HsEssTwJjgtkqNa6jUtw3vXWSmrNVSoVpgcP9+yiYTLU"
  + "UagzkOEn60Ulpeoc8pwN+UJaqrdE8/Ew5AU+GPxnEvjf5Og7EFKbcVRa/XemDGMUVGXZ/fPmu"
  + "pSjfhLJ/ZCyujg+r/KBhgW45Qe6Tm9AMB6u5tKqVrqOPu6k6akdvX4uwwWYb/pipTrsPIGIME"
  + "do+JS/QIoN5JcwDq9CapPaNEcad76O87NEKd+P+1hmIRnWcD6gwvAJ1iHG8QFW8tBw6OoTInZ"
  + "QqY9rzm4Bo1ZLuiw9z9tVEjlKkS+FVNkeqKmtfluFsI3mZTUc8zp0cHTb8eundxlE4k+n+BbZ"
  + "LIblcDZgjopis3X2rohPkiNCVGXdBQYbxM0TLXElhSpewu1HNMkTRHJfXiRDqQrL/MLFEHOyo"
  + "V9lXHjspJu3E2XF7m8/uvBaJbNaIN1fFmRjH0Cc7ukwXiDieS0fBk/mfoNM7Gprc08h3F9toY"
  + "efyIjy5YRWQo23BIgbjFu2KemyIow2fVAaaViLe7u0YycJapMjT/q+Isv1Uw6oPDYoNF6vxuf"
  + "T7JGbSUC/8eP8/tfwMAnoubHjQMpl4AAAAASUVORK5CYII=";

/**
 * Fennec のウィンドウへの組み込み
 *
 * @class
 * @implements arIStartupEventListener
 * @implements arIWindowEventListener
 */
let UnMHTFennecMenu = Object.freeze({
  /* ==== arIStartupEventListener ==== */

  /**
   * スタートアップ時のイベント
   *
   * @param   {Object} data
   *          Bootstrap データ
   * @param   {number} reason
   *          理由
   */
  onStartup: function(data, reason) {
    arWindowWatcher.addListener(this);
  },

  /* ==== arIWindowEventListener ==== */

  /**
   * ウィンドウが開いたイベント
   *
   * @param   {nsIDOMWindow} window
   *          対象のウィンドウ
   */
  onWindowOpen: function(window) {
  },

  /**
   * ウィンドウの DOM のロードイベント
   *
   * @param   {nsIDOMWindow} window
   *          対象のウィンドウ
   */
  onWindowDOMLoad: function(window) {
  },

  /**
   * ウィンドウのロードイベント
   *
   * @param   {nsIDOMWindow} window
   *          対象のウィンドウ
   */
  onWindowLoad: function(window) {
    if (!arWindowUtils.isBrowser(window)) {
      return;
    }

    arFennecMenu.add(window, {
      label: TEXT("menuitem.save.single.instant"),
      icon: UnMHTFennecMenu.iconURL
    }, function(UnMHTFileSaver) {
      /* Fennec のイベントハンドラは外の環境が見えないので
       * 必要な変数は渡しておく */
      try {
        UnMHTFileSaver.quicksave(window);
      } catch (e) {
        Cu.reportError(e + "\n" + e.stack);
      }
    }.bind(null, UnMHTFileSaver));
  },

  /**
   * ウィンドウのアンロードイベント
   *
   * @param   {nsIDOMWindow} window
   *          対象のウィンドウ
   */
  onWindowUnload: function(window) {
  },

  /* ==== private ==== */

  /**
   * アイコンの data scheme の URL
   * @type {string}
   */
  iconURL: iconURL
});

module.UnMHTFennecMenu = UnMHTFennecMenu;

})(this);
