"use strict";

this.EXPORTED_SYMBOLS = ["UnMHTStringBundle", "TEXT"];

(function(module) {

let { classes: Cc, interfaces: Ci, results: Cr, utils: Cu } = Components;
let { arStringBundle } = Cu.import("resource://unmht/modules/base/arStringBundle.jsm", {});

/**
 * StringBundle 管理
 * @type {arStringBundle}
 */
let UnMHTStringBundle
  = new arStringBundle("chrome://unmht/locale/unmht.properties");

/**
 * StringBundle から文字列を取得する
 *
 * @param   {string} name
 *          取得する文字列の名前
 * @param   {Array=} params
 *          フォーマット用のパラメータ (オプショナル)
 * @returns {string}
 *          StringBundle の文字列
 */
let TEXT = (name, params) => UnMHTStringBundle.get(name, params);

module.UnMHTStringBundle = UnMHTStringBundle;
module.TEXT = TEXT;

})(this);
