"use strict";

this.EXPORTED_SYMBOLS = ["arAppInfo"];

(function(module) {

let { classes: Cc, interfaces: Ci, results: Cr, utils: Cu } = Components;
let { Services } = Cu.import("resource://gre/modules/Services.jsm", {});

let id = "";
let appVersion = "";
try {
  id = Services.appinfo.ID;
  appVersion = Services.appinfo.platformVersion;
} catch (e) {
  Cu.reportError("Failed to get Application ID\n"
                 + e + "\n" + e.stack);
  /* FIXME:e10s: content プロセスで id が取得できない */
  id = "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}";
}

/**
 * アプリケーション情報
 *
 * @class
 */
let arAppInfo = Object.freeze({
  /**
   * Firefox かどうか
   * @type {boolean}
   */
  isFirefox: id == "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}",

  /**
   * Fennec かどうか
   * @type {boolean}
   */
  isFennec: id == "{aa3c5121-dab2-40e2-81ca-7ea25febc110}",

  /**
   * Thunderbird かどうか
   * @type {boolean}
   */
  isThunderbird: id == "{3550f703-e582-4d05-9a08-453d09bdfdc6}",

  /**
   * SeaMonkey かどうか
   * @type {boolean}
   */
  isSeaMonkey: id == "{92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}"
});

module.arAppInfo = arAppInfo;

})(this);
