"use strict";

this.EXPORTED_SYMBOLS = ["fromUint8Array", "toUint8Array"];

(function(module) {

/**
 * Uint8Array から string に変換する
 *
 * @param   {Uint8Array} arr
 *          文字コードの配列
 * @returns {string}
 *          文字列
 */
function fromUint8Array(arr) {
  let MAX_ARGC = 65535;
  let len = arr.length;
  let s = "";
  for (let i = 0; i < len; i += MAX_ARGC) {
    if (i + MAX_ARGC > len) {
      s += String.fromCharCode.apply(null, arr.subarray(i));
    } else {
      s += String.fromCharCode.apply(null, arr.subarray(i, i + MAX_ARGC));
    }
  }
  return s;
}

/**
 * string から Uint8Array に変換する
 *
 * @param   {string} str
 *          文字列
 * @returns {Uint8Array}
 *          文字コードの配列
 */
function toUint8Array(str) {
  let a = new Uint8Array(str.length);
  for (let i = 0, len = str.length; i < len; i += 1) {
    a[i] = str.charCodeAt(i);
  }
  return a;
}

module.fromUint8Array = fromUint8Array;
module.toUint8Array = toUint8Array;

})(this);
