"use strict";

this.EXPORTED_SYMBOLS = ["arLocaleUtils"];

(function(module) {

let { classes: Cc, interfaces: Ci, results: Cr, utils: Cu } = Components;
let { Services } = Cu.import("resource://gre/modules/Services.jsm", {});

const LOCALE_PREF = "general.useragent.locale";

/**
 * ロケール関連ユーティリティ
 *
 * @class
 */
let arLocaleUtils = Object.freeze({
  /**
   * 日本語かどうか返す
   *
   * @returns {boolean}
   *          日本語かどうか
   */
  isJapanese: function() {
    let locale = "ja-JP";
    try {
      locale = Services.prefs.getCharPref(LOCALE_PREF);
    } catch (e) {
    }

    if (locale.startsWith("ja")) {
      return true;
    }

    return false;
  }
});

module.arLocaleUtils = arLocaleUtils;

})(this);
