"use strict";

this.EXPORTED_SYMBOLS = ["arPseudoID"];

(function(module) {

let { classes: Cc, interfaces: Ci, results: Cr, utils: Cu } = Components;

/**
 * ID のカウンタ
 * @type {number}
 */
let count = 0;

/**
 * そこそこ一意な ID 生成器
 *
 * @class
 */
let arPseudoID = Object.freeze({
  /**
   * そこそこ一意な ID を生成する
   *
   * @returns {string}
   *          そこそこ一意な ID
   */
  gen: function() {
    let id
      = count.toString(16) + "."
      + this.randHex()
      + "." + Date.now().toString(16);
    count = (count + 1) % 0xffffffff;

    return id;
  },

  /**
   * 8 ケタのランダムな 16 進文字列を返す
   *
   * @returns {string}
   *          8 ケタのランダムな 16 進文字列
   */
  randHex: function() {
    return ("0000000" + Math.floor(Math.random() * 0xffffffff).toString(16)).slice(-8);
  }
});

module.arPseudoID = arPseudoID;

})(this);
